package me.fivevl.musictrivia

import com.sedmelluq.discord.lavaplayer.player.AudioPlayer
import com.sedmelluq.discord.lavaplayer.track.playback.MutableAudioFrame
import net.dv8tion.jda.api.audio.AudioSendHandler
import java.nio.Buffer
import java.nio.ByteBuffer


class AudioPlayerSendHandler(player: AudioPlayer?) : AudioSendHandler {
    private lateinit var audioPlayer: AudioPlayer
    private lateinit var buffer: ByteBuffer
    private lateinit var frame: MutableAudioFrame

    init {
        this.audioPlayer = player
        buffer = ByteBuffer.allocate(1024)
        frame = MutableAudioFrame()
        frame.setBuffer(buffer)
    }

    override fun canProvide(): Boolean {
        return audioPlayer!!.provide(frame)
    }

    override fun provide20MsAudio(): ByteBuffer {
        (buffer as Buffer?)?.flip()
        return buffer
    }

    override fun isOpus(): Boolean {
        return true
    }
}